;****************************************************************************
;
;                    
;
; :   (. )
;        AV@72.ru
;****************************************************************************

 #include <p16f628.inc>

 ORG 0
	data	H'A',H'A',H'B'
	goto	Program

 ; -----------------  -----------------

	movwf	W_copy
	movf	STATUS,w
	movwf	STATUS_copy
	bcf	INTCON,T0IF
	movlw	B'00000001'  ;   
	xorwf	FLAGS,f      ;    
	bcf	PORTA,Flcd   ; Fosc/4/256/16,  
	btfsc	FLAGS,RA1    ;  240 
	bsf	PORTA,Flcd

ShowOne	btfss	FLAGS,One    ;  ,
	goto	NotShow_One  ;   "1"
	bsf	PORTB,BC2    ;   
	btfsc	FLAGS,RA1
	bcf	PORTB,BC2
	goto	ShowMin
NotShow_One
	bcf	PORTB,BC2
	btfsc	FLAGS,RA1
	bsf	PORTB,BC2

ShowMin	btfsc	FLAGS,Sign   ;  ,
	goto	NotShow_Min  ;   "-"
	bsf	PORTB,G1     ;   
	btfsc	FLAGS,RA1
	bcf	PORTB,G1
	goto	ENDINT
NotShow_Min
	bcf	PORTB,G1
	btfsc	FLAGS,RA1
	bsf	PORTB,G1
ENDINT
	movf	STATUS_copy,w
	movwf	STATUS
	swapf	W_copy,f
	swapf	W_copy,w
	retfie

 ; ------------   ------------

	CBLOCK  H'26'
STATUS_copy	;  
W_copy		;  W  STATUS
Ind1		;     
Ind2		; (Ind1 -  , .. )
CLK_count	;        1764
FLAGS		;  
Temperature     ;  
DELAY_reg_1	;  
DELAY_reg_2	;  
	ENDC

 ; ------------   I2C ------------

Bus_Status	equ  H'21' ;    I2C
_Bus_Busy	equ  0     ;  "1" -  
_Txmt_Progr	equ  1     ;  "1" -   
_Rcv_Progr	equ  2     ;  "1" -   
_Txmt_Success	equ  3     ;  "1" -    
_Rcv_Success	equ  4     ;  "1" -    
_ACK_Error	equ  5     ;  "1" -     

Bus_Control	equ  H'22' ;    I2C
_Slave_RW	equ  0     ; "1" -  , "0" -  
_Last_Byte	equ  1     ; "1" ,    

DataByte	equ  H'23' ;      
LSB		equ  0     ;  

DataByteCopy	equ  H'24'
BitCount	equ  H'25' ;      

 ; --------   FLAGS --------

RA1   equ  0 ;     
One   equ  1 ;  "1" -      
Sign  equ  2 ;   (0 - , 1 - )

 ; -----------    -----------

Flcd	equ  1 ;   
_SDA	equ  6 ;  I2C
_SCL	equ  7

 ; -----------   B -----------

CLK1	equ  1 ;  
CLK2	equ  2 ;  1764
RST	equ  3 ;    1764
BC2	equ  4 ;     2-  ( 1)
G1	equ  5 ;  G 1-  ()
PWD	equ  6 ;   (  "0")

 ; ----------- ,   ----------
 ; ------------   CONFIG  DS1631 ------------
 ;     " " (51h),
 ; " " (22h), " " (54h)
 ;  "   Config" (h)

Command_to_DS1631   macro   Command,Config
		    local   Stop

	bcf	Bus_Control,_Slave_RW  ;  
	call	TxmtStartBit

	movlw	B'10011111'            ;    DS1631  0..2 = 111
	movwf	DataByte	       ; load addr to DataByte for transmission
	bcf	DataByte,LSB
	btfsc	Bus_Control,_Slave_RW  ; if skip then write operation
	bsf	DataByte,LSB	       ; Read Operation
	call	Send_data              ; if successful, then _Txmt_Success bit is set
	btfsc	Bus_Status,_ACK_Error  ; skip if NACK, device is not present or not responding
	goto	BUS_ERROR

	movlw	Command   ;  
	movwf	DataByte
	call	Send_data
	btfsc	Bus_Status,_ACK_Error
	goto	BUS_ERROR

	movlw	Command   ;    0
	xorlw	H'AC'     ; (   "Config"),
	BZ	$+2       ;    
	goto	Stop

	movlw	Config    ;  , 
	movwf	DataByte  ;     "Config"
	call	Send_data
	btfsc	Bus_Status,_ACK_Error
	goto	BUS_ERROR
Stop
	call	TxmtStopBit
 endm

 ; -----------      -----------
 ; ----------- , L    -----------
 ; "Command_byte" ,      :
 ; 0xA1 - , 0xA2 - L, 0x - 
 ;   (  )
 ;    "Temperature"

Read_from_DS1631   macro   Command_byte

	bcf	Bus_Control,_Slave_RW    ; set for write operation
	call	TxmtStartBit

	movlw	B'10011111'              ;    DS1631  0..2 = 111
	movwf	DataByte		 ; load addr to DataByte for transmission
	bcf	DataByte,LSB
	btfsc	Bus_Control,_Slave_RW    ; if skip then write operation
	bsf	DataByte,LSB	         ; Read Operation
	call	Send_data                ; if successful, then _Txmt_Success bit is set
	btfsc	Bus_Status,_ACK_Error    ; skip if NACK, device is not present or not responding
	goto	BUS_ERROR

	movlw	Command_byte             ;   
	movwf	DataByte
	call	Send_data                ; if successful, then _Txmt_Success bit is set
	btfsc	Bus_Status,_ACK_Error    ; skip if NACK, device is not present or not responding
	goto	BUS_ERROR

	call	TxmtStartBit

	bsf	Bus_Control,_Slave_RW    ; set for read operation
	movlw	B'10011111'              ;    DS1631  0..2 = 111
	movwf	DataByte		 ; load addr to DataByte for transmission
	bcf	DataByte,LSB
	btfsc	Bus_Control,_Slave_RW    ; if skip then write operation
	bsf	DataByte,LSB	         ; Read Operation
	call	Send_data                ; if successful, then _Txmt_Success bit is set
	btfsc	Bus_Status,_ACK_Error    ; skip if NACK, device is not present or not
responding
	goto	BUS_ERROR

	bsf	Bus_Control,_Last_Byte   ;   
	call	Get_data
	movfw	DataByte
	movwf	Temperature

        call    TxmtStopBit
 endm

 ; -----------------  -----------------

Program
	clrf	PORTB
	clrf	PORTA
	movlw	B'00000111'    ;  
	movwf	CMCON
	bsf	STATUS,RP0     ;  1
	bsf	PCON,OSCF      ;     4 
        clrf	TRISB          ;   B -  
	clrf	TRISA          ;   A -  
        bcf     OPTION_REG,T0CS;  0 -   
        bcf     OPTION_REG,PSA ;  -   0
        bsf     OPTION_REG,PS0 ;   - 16 (PS2..PS0 = 011)
        bsf     OPTION_REG,PS1
        bcf     OPTION_REG,PS2
	bcf	STATUS,RP0     ;  0
	clrf	FLAGS
	clrf	Bus_Control
	clrf	Bus_Status
	clrf	BitCount
	bsf	PORTA,_SDA     ;  
	bsf	PORTA,_SCL     ;   I2C
        bsf     INTCON,T0IE    ;     0

 ; *************************************************************************
 ;                         
 ; *************************************************************************

 ;     "Config"   00000001,
 ;   9     
 ;    - 93,75 .

	Command_to_DS1631 H'AC',01
	Command_to_DS1631 H'51',00 ;   "Start Convert"
	call	DELAY_100ms        ;    100 .
	Read_from_DS1631  H'AA'    ;   

	bcf	FLAGS,Sign	;   
	btfss	Temperature,7   ;   ,  
	bsf	FLAGS,Sign      ;  

	btfsc	FLAGS,Sign      ;    , 
	goto	$+3             ;      ,
	comf	Temperature,f   ;   DS1631  
	incf	Temperature,f   ;       

	call	BIN_to_BCD      ;    
	call	LOAD_to_LCD     ;        DD2, DD3
	bsf	INTCON,GIE	;  
	goto	POWER_DOWN

BUS_ERROR
	movlw	0               ;   DS1631  ,
	movwf	Ind1            ;     "- 00"
	movwf	Ind2
	bcf	FLAGS,Sign
	call	LOAD_to_LCD
	bsf	INTCON,GIE
	goto	POWER_DOWN

POWER_DOWN
	movlw	D'30'		;  3 
	movwf	Temperature	;  
	call	DELAY_100ms	;   
	decfsz	Temperature,f
	goto	$-2
	bsf	PORTB,PWD	;  !

 ; ****************    I2C ****************

TxmtStartBit

	bsf	PORTA,_SDA
	bsf	PORTA,_SCL
	call	Delay50uSec
	bcf	PORTA,_SDA
	call	Delay50uSec
	bsf	Bus_Status,_Bus_Busy
	return

 ; ---------------------------------------------------

TxmtStopBit

	bcf	PORTA,_SDA
	bcf	PORTA,_SCL
	bsf	PORTA,_SCL
	call	Delay50uSec
	bsf	PORTA,_SDA
	call	Delay50uSec
	bcf	Bus_Status,_Bus_Busy
	return

 ; ---------------------------------------------------

Send_data

	movfw	DataByte
	movwf	DataByteCopy           ; make copy of DataByte
	bsf	Bus_Status,_Txmt_Progr     ; set Bus status for txmt progress
	bcf	Bus_Status,_Txmt_Success   ; reset status bit
	movlw	8
	movwf	BitCount
TxmtNextBit
	bcf	PORTA,_SCL
	rlf     DataByteCopy,f	; MSB first, Note DataByte Is Lost
	bcf	PORTA,_SDA
	btfsc	STATUS,C
	bsf	PORTA,_SDA
	call	Delay50uSec	; guareentee min LOW TIME tLOW & Setup time
	bsf	PORTA,_SCL		; set clock high , check if clock is high, else clock being stretched
	call	Delay50uSec	; guareentee min HIGH TIME tHIGH
	decfsz	BitCount,f
	goto	TxmtNextBit
 ; Check for Ack
	bcf	PORTA,_SCL
	bsf	PORTA,_SDA	; Release SDA line for Slave to pull down
	call	Delay50uSec	; guareentee min LOW TIME tLOW & Setup time
	bsf	PORTA,_SCL	; clock for slave to ACK
	call	Delay50uSec	; guareentee min HIGH TIME tHIGH
	btfsc	PORTA,_SDA	; SDA should be pulled low by slave if OK
        goto	_TxmtErrorAck
	bcf	PORTA,_SCL

	bcf	Bus_Status,_Txmt_Progr   ; reset TXMT bit in Bus Status
	bsf	Bus_Status,_Txmt_Success ; transmission successful
	bcf	Bus_Status,_ACK_Error    ; ACK OK
	return
_TxmtErrorAck
	bsf	PORTA,_SDA               ; tristate SDA
	bsf	PORTA,_SCL               ; tristate SCL
	bcf	Bus_Status,_Bus_Busy     ; Bus Not Busy, TEMP ????, set/clear on Start &
Stop
	bcf	Bus_Status,_Txmt_Progr   ; reset TXMT bit in Bus Status
	bcf	Bus_Status,_Txmt_Success ; transmission NOT successful
	bsf	Bus_Status,_ACK_Error    ; No ACK From Slave
	return

 ; ---------------------------------------------------

Get_data

	bsf	Bus_Status,_Rcv_Progr	; set Bus status for txmt progress
	bcf	Bus_Status,_Rcv_Success	; reset status bit

	movlw	8
	movwf	BitCount
RcvNextBit
	bcf	PORTA,_SCL
	bsf	PORTA,_SDA	; can be removed from loop
	call	Delay50uSec	; guareentee min LOW TIME tLOW & Setup time
	bsf	PORTA,_SCL	; clock high, data sent by slave
	call	Delay50uSec	; guareentee min HIGH TIME tHIGH

	bcf	STATUS,C
	btfsc	PORTA,_SDA
	bsf	STATUS,C
				; TEMP ???? DO 2 out of 3 Majority detect
	rlf	DataByte,f	; left shift data (MSB first)
	decfsz	BitCount,f
	goto	RcvNextBit

 ; Generate ACK bit if not last byte to be read,
 ; if last byte generate NACK
 ; do not send ACK on last byte, main routine will send a STOP bit

	bcf	PORTA,_SCL
	bcf	PORTA,_SDA              ; ACK by pulling SDA low
	btfsc	Bus_Control,_Last_Byte
	bsf	PORTA,_SDA              ; if last byte, send NACK by setting SDA high
	call	Delay50uSec             ; guareentee min LOW TIME tLOW & Setup time
	bsf	PORTA,_SCL
	call	Delay50uSec             ; guareentee min HIGH TIME tHIGH
RcvEnd
	bcf	PORTA,_SCL              ; reset clock
	bcf	Bus_Status,_Rcv_Progr	; reset TXMT bit in Bus Status
	bsf	Bus_Status,_Rcv_Success	; transmission successful
	bcf	Bus_Status,_ACK_Error	; ACK OK
	return

 ; ****************   ****************
 ; --------------     --------------

LOAD_to_LCD
	bsf	PORTB,RST   ;   
	bcf	PORTB,RST
K176IE4_1
	movfw	Ind1        ;      
	movwf	CLK_count
	xorlw	0
	BZ	K176IE4_2
	bsf	PORTB,CLK1
	bcf	PORTB,CLK1
	decfsz	CLK_count,f
	goto	$-3
K176IE4_2
	movfw	Ind2        ;      
	movwf	CLK_count
	xorlw	0
	BZ	Go_back
	bsf	PORTB,CLK2
	bcf	PORTB,CLK2
	decfsz	CLK_count,f
	goto	$-3
Go_back
	return

 ; -----------      -----------

BIN_to_BCD
	clrf 	Ind1
	movfw	Temperature
	movwf	Ind2
GTENTH
	movlw	D'10'
	subwf	Ind2,w
	btfss	STATUS,C
	goto	GHUNDRED
	movwf	Ind2
	incf	Ind1,f
	goto	GTENTH
GHUNDRED
	movlw	D'10'
	subwf	Ind1,w
	btfss	STATUS,C
	goto	OVER
	bsf	FLAGS,One
	movwf	Ind1
OVER	return

 ; ------------   100  ------------

DELAY_100ms
	movlw	D'130'
	movwf	DELAY_reg_1
	movlw	H'FF'
	movwf	DELAY_reg_2
LOOP
	decfsz	DELAY_reg_2,f
	goto	LOOP
	decfsz	DELAY_reg_1,f
	goto	LOOP
	return

 ; ---------------  50  ---------------

Delay50uSec
	movlw	D'15'
	movwf	DELAY_reg_1
	decfsz	DELAY_reg_1,f
	goto	$-1
	return

  END
